package DE_EPAGES::Object::t::ChildrenDepth;
use base DE_EPAGES::Core::API::Test;

use DE_EPAGES::Test::Mock::MockifyEpagesObject;
use Test::More;

use strict;

sub test {
    my $self = shift;

    $self->TestCountChildrenDepth();
    done_testing();

    return;
}
sub TestCountChildrenDepth {
    my $self = shift;

    my $TestObject = $self->_createMockedObject();
    my $Child1 = $TestObject->children->[0];
    my $Child2a = $Child1->children->[0];
    my $Child2b = $Child1->children->[1];
    my $Child2c = $Child1->children->[2];
    my $Child4 = $Child2a->children->[0]->children->[0];
    is( $Child4->countChildrenDepth, 0, 'Children Depth of Child4 = 0' );
    is( $Child2a->countChildrenDepth, 2, 'Children Depth of Child2a = 2' );
    is( $Child2b->countChildrenDepth, 1, 'Children Depth of Child2b = 1' );
    is( $Child2c->countChildrenDepth, 3, 'Children Depth of Child2c = 3' );
    is( $TestObject->countChildrenDepth, 5, 'Children Depth of root object = 5' );
}

sub _createMockedObject {
    my $self = shift;

    return DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
        'DE_EPAGES::Object::API::Object::Object', {
            'Children' => [
                DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                    'DE_EPAGES::Object::API::Object::Object', {
                        'Children' => [
                            DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                'DE_EPAGES::Object::API::Object::Object', {
                                    'Children' => [
                                        DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                            'DE_EPAGES::Object::API::Object::Object', {
                                                'Children' => [
                                                    DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                                        'DE_EPAGES::Object::API::Object::Object', {
                                                            'Children' => []
                                                        }
                                                    )->getMockObject()
                                                ]
                                            }
                                        )->getMockObject()
                                    ]
                                }
                            )->getMockObject(),
                            DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                'DE_EPAGES::Object::API::Object::Object', {
                                    'Children' => [
                                        DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                            'DE_EPAGES::Object::API::Object::Object', {
                                                'Children' => []
                                            }
                                        )->getMockObject()
                                    ]
                                }
                            )->getMockObject(),
                            DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                'DE_EPAGES::Object::API::Object::Object', {
                                    'Children' => [
                                        DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                            'DE_EPAGES::Object::API::Object::Object', {
                                                'Children' => [
                                                    DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                                        'DE_EPAGES::Object::API::Object::Object', {
                                                            'Children' => [
                                                                DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
                                                                    'DE_EPAGES::Object::API::Object::Object', {
                                                                        'Children' => []
                                                                    }
                                                                )->getMockObject()
                                                            ]
                                                        }
                                                    )->getMockObject()
                                                ]
                                            }
                                        )->getMockObject()
                                    ]
                                }
                            )->getMockObject()
                        ]
                    }
                )->getMockObject()
            ]
        }
    )->getMockObject();
}

__PACKAGE__->runScript;
1;