#========================================================================================
# package      DE_EPAGES::Spreedly::t::unit::PaymentInformation
# base         DE_EPAGES::Core::API::Test
# state        public
#----------------------------------------------------------------------------------------
# description  unit test for API::Object::PaymentInformation
#========================================================================================
package DE_EPAGES::Spreedly::t::unit::PaymentInformation;
use base DE_EPAGES::Core::API::Test;

use DE_EPAGES::Spreedly::API::Object::PaymentInformation;

use DE_EPAGES::Test::Mock::EpagesObject;
use DE_EPAGES::Test::Mock::MockifyServlet;
use Test::Exception;
use Test::MockObject::Extends;
use Test::More;

use strict;

use constant PAYMENT_INFO_TOKEN => 'EWdi0wRvmXUX5pOqPgvhTUtV8g3';


sub test {
    my $self = shift;

    $self->_test_set_and_get_token();

    done_testing();
}

#----------------------------------------------------------------------------------------
# Tests
#----------------------------------------------------------------------------------------
sub _test_set_and_get_token {
    my $self        = shift;
    my $SubTestName = ( caller(0) )[3];

    my $MockedPayment = $self->_createPaymentInformation();
    $MockedPayment->setToken(PAYMENT_INFO_TOKEN);

    is( $MockedPayment->getToken(), PAYMENT_INFO_TOKEN, "$SubTestName - line item payment holds the right payment method token." );

    return;
}

#----------------------------------------------------------------------------------------
# Helpers
#----------------------------------------------------------------------------------------

sub _createPaymentInformation {
    my $self = shift;

    my $MockedLineItemPayment = $self->_createLineItemPaymentSpreedly();

    my $Mockify = DE_EPAGES::Test::Mock::Mockify->new('DE_EPAGES::Spreedly::API::Object::PaymentInformation', [ $MockedLineItemPayment ]);

    return $Mockify->getMockObject();
}

sub _createLineItemPaymentSpreedly {
    my $self = shift;

    my $hAttributes = {
        'PaymentInformationToken' => undef
    };

    return DE_EPAGES::Test::Mock::EpagesObject->new( 'DE_EPAGES::Spreedly::API::Object::LineItemPaymentSpreedly', $hAttributes );
}


__PACKAGE__->runScript();

1;
